"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KEY_CONTEXT_DESTINATION = exports.KEY_CONTEXT_SOURCES = exports.ActorContextPreprocessSourceToDestination = void 0;
const bus_context_preprocess_1 = require("@comunica/bus-context-preprocess");
/**
 * A comunica Source To Destination Context Preprocess Actor.
 */
class ActorContextPreprocessSourceToDestination extends bus_context_preprocess_1.ActorContextPreprocess {
    constructor(args) {
        super(args);
    }
    async test(action) {
        return true;
    }
    async run(action) {
        if (action.context && action.context.get(exports.KEY_CONTEXT_SOURCES) && !action.context.get(exports.KEY_CONTEXT_DESTINATION)) {
            const sources = action.context.get(exports.KEY_CONTEXT_SOURCES);
            if (sources.length === 1) {
                return { context: action.context.set(exports.KEY_CONTEXT_DESTINATION, sources[0]) };
            }
        }
        return action;
    }
}
exports.ActorContextPreprocessSourceToDestination = ActorContextPreprocessSourceToDestination;
exports.KEY_CONTEXT_SOURCES = '@comunica/bus-rdf-resolve-quad-pattern:sources';
exports.KEY_CONTEXT_DESTINATION = '@comunica/bus-rdf-update-quads:destination';
//# sourceMappingURL=ActorContextPreprocessSourceToDestination.js.map