"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchInitPreprocessor = void 0;
const http_1 = require("http");
const https_1 = require("https");
/**
 * Overrides the HTTP agent to perform better.
 */
class FetchInitPreprocessor {
    constructor(agentOptions) {
        const httpAgent = new http_1.Agent(agentOptions);
        const httpsAgent = new https_1.Agent(agentOptions);
        this.agent = (_parsedURL) => _parsedURL.protocol === 'http:' ? httpAgent : httpsAgent;
    }
    handle(init) {
        return Object.assign(Object.assign({}, init), { agent: this.agent });
    }
}
exports.FetchInitPreprocessor = FetchInitPreprocessor;
//# sourceMappingURL=FetchInitPreprocessor.js.map