import type { IActorQueryOperationOutput, IActorQueryOperationTypedMediatedArgs } from '@comunica/bus-query-operation';
import { ActorQueryOperationTypedMediated } from '@comunica/bus-query-operation';
import type { ActionContext, IActorTest } from '@comunica/core';
import type { Algebra } from 'sparqlalgebrajs';
/**
 * A [Query Operation](https://github.com/comunica/comunica/tree/master/packages/bus-query-operation) actor
 * that handles SPARQL add operations.
 */
export declare class ActorQueryOperationAddRewrite extends ActorQueryOperationTypedMediated<Algebra.Add> {
    private readonly factory;
    constructor(args: IActorQueryOperationTypedMediatedArgs);
    testOperation(pattern: Algebra.Add, context: ActionContext): Promise<IActorTest>;
    runOperation(pattern: Algebra.Add, context: ActionContext): Promise<IActorQueryOperationOutput>;
}
