import type { IActorQueryOperationOutput, IActorQueryOperationTypedMediatedArgs } from '@comunica/bus-query-operation';
import { ActorQueryOperationTypedMediated } from '@comunica/bus-query-operation';
import type { IActionRdfUpdateQuads, IActorRdfUpdateQuadsOutput } from '@comunica/bus-rdf-update-quads';
import type { ActionContext, IActorTest, Actor, Mediator } from '@comunica/core';
import type { Algebra } from 'sparqlalgebrajs';
/**
 * A [Query Operation](https://github.com/comunica/comunica/tree/master/packages/bus-query-operation) actor
 * that handles SPARQL clear operations.
 */
export declare class ActorQueryOperationClear extends ActorQueryOperationTypedMediated<Algebra.Clear> {
    readonly mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
    constructor(args: IActorQueryOperationClearArgs);
    testOperation(pattern: Algebra.Clear, context: ActionContext): Promise<IActorTest>;
    runOperation(pattern: Algebra.Clear, context: ActionContext): Promise<IActorQueryOperationOutput>;
}
export interface IActorQueryOperationClearArgs extends IActorQueryOperationTypedMediatedArgs {
    mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
}
