"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActorQueryOperationUpdateCompositeUpdate = void 0;
const bus_query_operation_1 = require("@comunica/bus-query-operation");
/**
 * A comunica Update CompositeUpdate Query Operation Actor.
 */
class ActorQueryOperationUpdateCompositeUpdate extends bus_query_operation_1.ActorQueryOperationTypedMediated {
    constructor(args) {
        super(args, 'compositeupdate');
    }
    async testOperation(pattern, context) {
        bus_query_operation_1.ActorQueryOperation.throwOnReadOnly(context);
        return true;
    }
    async runOperation(pattern, context) {
        const updateResult = (async () => {
            // Execute update operations in sequence
            for (const operation of pattern.updates) {
                const subResult = bus_query_operation_1.ActorQueryOperation
                    .getSafeUpdate(await this.mediatorQueryOperation.mediate({ operation, context }));
                await subResult.updateResult;
            }
        })();
        return {
            type: 'update',
            updateResult,
        };
    }
}
exports.ActorQueryOperationUpdateCompositeUpdate = ActorQueryOperationUpdateCompositeUpdate;
//# sourceMappingURL=ActorQueryOperationUpdateCompositeUpdate.js.map