import type { IActorQueryOperationOutput, IActorQueryOperationTypedMediatedArgs } from '@comunica/bus-query-operation';
import { ActorQueryOperationTypedMediated } from '@comunica/bus-query-operation';
import type { ActionContext, IActorTest } from '@comunica/core';
import type { Algebra } from 'sparqlalgebrajs';
/**
 * A [Query Operation](https://github.com/comunica/comunica/tree/master/packages/bus-query-operation) actor that
 * handles SPARQL copy operations.
 */
export declare class ActorQueryOperationCopyRewrite extends ActorQueryOperationTypedMediated<Algebra.Copy> {
    private readonly factory;
    constructor(args: IActorQueryOperationTypedMediatedArgs);
    testOperation(pattern: Algebra.Copy, context: ActionContext): Promise<IActorTest>;
    runOperation(pattern: Algebra.Copy, context: ActionContext): Promise<IActorQueryOperationOutput>;
}
