import type { IActorQueryOperationOutput, IActorQueryOperationTypedMediatedArgs } from '@comunica/bus-query-operation';
import { ActorQueryOperationTypedMediated } from '@comunica/bus-query-operation';
import type { IActionRdfUpdateQuads, IActorRdfUpdateQuadsOutput } from '@comunica/bus-rdf-update-quads';
import type { ActionContext, Actor, IActorTest, Mediator } from '@comunica/core';
import type { Algebra } from 'sparqlalgebrajs';
/**
 * A [Query Operation](https://github.com/comunica/comunica/tree/master/packages/bus-query-operation) actor that
 * handles SPARQL create operations.
 */
export declare class ActorQueryOperationCreate extends ActorQueryOperationTypedMediated<Algebra.Create> {
    readonly mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
    constructor(args: IActorQueryOperationCreateArgs);
    testOperation(pattern: Algebra.Create, context: ActionContext): Promise<IActorTest>;
    runOperation(pattern: Algebra.Create, context: ActionContext): Promise<IActorQueryOperationOutput>;
}
export interface IActorQueryOperationCreateArgs extends IActorQueryOperationTypedMediatedArgs {
    mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
}
