import type { IActorQueryOperationOutput, IActorQueryOperationTypedMediatedArgs } from '@comunica/bus-query-operation';
import { ActorQueryOperationTypedMediated } from '@comunica/bus-query-operation';
import type { IActionRdfUpdateQuads, IActorRdfUpdateQuadsOutput } from '@comunica/bus-rdf-update-quads';
import type { Actor, IActorTest, Mediator } from '@comunica/core';
import { ActionContext } from '@comunica/core';
import type { Algebra } from 'sparqlalgebrajs';
/**
 * A [Query Operation](https://github.com/comunica/comunica/tree/master/packages/bus-query-operation) actor
 * that handles SPARQL load operations.
 */
export declare class ActorQueryOperationLoad extends ActorQueryOperationTypedMediated<Algebra.Load> {
    readonly mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
    private readonly factory;
    private readonly constructOperation;
    constructor(args: IActorQueryOperationLoadArgs);
    testOperation(pattern: Algebra.Load, context: ActionContext): Promise<IActorTest>;
    runOperation(pattern: Algebra.Load, context: ActionContext): Promise<IActorQueryOperationOutput>;
}
export interface IActorQueryOperationLoadArgs extends IActorQueryOperationTypedMediatedArgs {
    mediatorUpdateQuads: Mediator<Actor<IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>, IActionRdfUpdateQuads, IActorTest, IActorRdfUpdateQuadsOutput>;
}
export declare const KEY_CONTEXT_SOURCES = "@comunica/bus-rdf-resolve-quad-pattern:sources";
export declare const KEY_CONTEXT_LENIENT = "@comunica/actor-init-sparql:lenient";
