import type { IActionHttp, IActorHttpOutput } from '@comunica/bus-http';
import type { IActionRdfSerialize, IActionRootRdfSerialize, IActorOutputRootRdfSerialize, IActorTestRootRdfSerialize } from '@comunica/bus-rdf-serialize';
import type { IActionRdfUpdateHypermedia, IActorRdfUpdateHypermediaOutput } from '@comunica/bus-rdf-update-hypermedia';
import { ActorRdfUpdateHypermedia } from '@comunica/bus-rdf-update-hypermedia';
import type { IActorArgs, IActorTest, Actor, Mediator } from '@comunica/core';
/**
 * A comunica Patch SPARQL Update RDF Update Hypermedia Actor.
 */
export declare class ActorRdfUpdateHypermediaPatchSparqlUpdate extends ActorRdfUpdateHypermedia {
    readonly mediatorHttp: Mediator<Actor<IActionHttp, IActorTest, IActorHttpOutput>, IActionHttp, IActorTest, IActorHttpOutput>;
    readonly mediatorRdfSerialize: Mediator<Actor<IActionRootRdfSerialize, IActorTestRootRdfSerialize, IActorOutputRootRdfSerialize>, IActionRootRdfSerialize, IActorTestRootRdfSerialize, IActorOutputRootRdfSerialize>;
    constructor(args: IActorRdfUpdateHypermediaPatchSparqlUpdateArgs);
    testMetadata(action: IActionRdfUpdateHypermedia): Promise<IActorTest>;
    run(action: IActionRdfUpdateHypermedia): Promise<IActorRdfUpdateHypermediaOutput>;
}
export interface IActorRdfUpdateHypermediaPatchSparqlUpdateArgs extends IActorArgs<IActionRdfUpdateHypermedia, IActorTest, IActorRdfUpdateHypermediaOutput> {
    mediatorHttp: Mediator<Actor<IActionHttp, IActorTest, IActorHttpOutput>, IActionHttp, IActorTest, IActorHttpOutput>;
    mediatorRdfSerialize: Mediator<Actor<IActionRdfSerialize, IActorTestRootRdfSerialize, IActorOutputRootRdfSerialize>, IActionRdfSerialize, IActorTestRootRdfSerialize, IActorOutputRootRdfSerialize>;
}
