import { Logger } from '@comunica/core';
/**
 * A logger that pretty-prints everything.
 */
export declare class LoggerPretty extends Logger {
    private readonly level;
    private readonly levelOrdinal;
    private readonly actors?;
    constructor(args: ILoggerPrettyArgs);
    debug(message: string, data?: any): void;
    error(message: string, data?: any): void;
    fatal(message: string, data?: any): void;
    info(message: string, data?: any): void;
    trace(message: string, data?: any): void;
    warn(message: string, data?: any): void;
    protected log(level: string, message: string, data?: any): void;
}
export interface ILoggerPrettyArgs {
    /**
     * The minimum logging level.
     */
    level: string;
    /**
     * A whitelist of actor IRIs to log for.
     */
    actors?: Record<string, boolean>;
}
