import { encode } from '../runtime/base64url.mjs';
import keyToJWK from '../runtime/key_to_jwk.mjs';

async function fromKeyLike(key) {
    if (key instanceof Uint8Array) {
        return {
            kty: 'oct',
            k: encode(key),
        };
    }
    return keyToJWK(key);
}

export default fromKeyLike;
export { fromKeyLike };
