"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ConfigurationError_1 = __importDefault(require("./ConfigurationError"));
const NotImplementedError_1 = __importDefault(require("./NotImplementedError"));
describe("errors", () => {
    const errors = [
        {
            name: "ConfigurationError",
            class: ConfigurationError_1.default,
            params: ["Bad Config"],
            message: "Bad Config",
        },
        {
            name: "NotImplementedError",
            class: NotImplementedError_1.default,
            params: ["FunctionName"],
            message: "[FunctionName] is not implemented",
        },
    ];
    errors.forEach((err) => {
        it(`Should throw [${err.name}]`, () => {
            expect(() => {
                const error = new err.class(...err.params);
                throw error;
            }).toThrow(err.message);
        });
    });
});
//# sourceMappingURL=errors.spec.js.map