import IStorageUtility from "../../storage/IStorageUtility";
import ILoginOptions from "../ILoginOptions";
import { IClient } from "./IClient";
import { IIssuerConfig } from "./IIssuerConfig";
export interface IClientRegistrarOptions {
    sessionId: string;
    clientName?: string;
    redirectUrl?: string;
    registrationAccessToken?: string;
}
export interface IClientRegistrar {
    getClient(options: IClientRegistrarOptions, issuerConfig: IIssuerConfig): Promise<IClient>;
}
export declare function determineSigningAlg(supported: string[], preferred: string[]): string | null;
export declare function handleRegistration(options: ILoginOptions, issuerConfig: IIssuerConfig, storageUtility: IStorageUtility, clientRegistrar: IClientRegistrar): Promise<IClient>;
