import { fetch } from "cross-fetch";
import { JWK } from "@inrupt/jose-legacy-modules";
import IHandleable from "../../../util/handlerPattern/IHandleable";
import { ISessionInfo } from "../../../sessionInfo/ISessionInfo";
export declare type RedirectResult = ISessionInfo & {
    fetch: typeof fetch;
};
declare type IRedirectHandler = IHandleable<[
    string,
    ((newToken: string) => unknown)?
], RedirectResult>;
export default IRedirectHandler;
export declare function fetchJwks(jwksIri: string, issuerIri: string): Promise<JWK>;
export declare function getWebidFromTokenPayload(idToken: string, jwksIri: string, issuerIri: string, clientId: string): Promise<string>;
