import { ISessionInfo, ISessionInternalInfo } from "./ISessionInfo";
export interface ISessionInfoManagerOptions {
    loggedIn?: boolean;
    webId?: string;
}
export interface ISessionInfoManager {
    update(sessionId: string, options: ISessionInfoManagerOptions): Promise<void>;
    get(sessionId: string): Promise<(ISessionInfo & ISessionInternalInfo) | undefined>;
    getAll(): Promise<(ISessionInfo & ISessionInternalInfo)[]>;
    register(sessionId: string): Promise<void>;
    getRegisteredSessionIdAll(): Promise<string[]>;
    clear(sessionId: string): Promise<void>;
    clearAll(): Promise<void>;
}
export declare const USER_SESSION_PREFIX = "solidClientAuthenticationUser";
