"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const InMemoryStorage_1 = __importDefault(require("./InMemoryStorage"));
describe("InMemoryStorage", () => {
    const nodeStorage = new InMemoryStorage_1.default();
    it("can set an item", async () => {
        await expect(nodeStorage.set("a", "A")).resolves.not.toBeNull();
    });
    it("can get an item", async () => {
        expect(await nodeStorage.get("a")).toEqual("A");
    });
    it("returns undefined if the key does not exist", async () => {
        expect(await nodeStorage.get("doesNotExist")).toBeUndefined();
    });
    it("can delete an item", async () => {
        await nodeStorage.delete("a");
        expect(await nodeStorage.get("a")).toBeUndefined();
    });
});
//# sourceMappingURL=InMemoryStorage.spec.js.map