import { ILoginInputOptions, ILoginHandler, ILogoutHandler, IRedirectHandler, ISessionInfo, ISessionInternalInfo, ISessionInfoManager } from "@inrupt/solid-client-authn-core";
export default class ClientAuthentication {
    private loginHandler;
    private redirectHandler;
    private logoutHandler;
    private sessionInfoManager;
    constructor(loginHandler: ILoginHandler, redirectHandler: IRedirectHandler, logoutHandler: ILogoutHandler, sessionInfoManager: ISessionInfoManager);
    login: (sessionId: string, options: ILoginInputOptions, onNewRefreshToken?: ((newToken: string) => unknown) | undefined) => Promise<ISessionInfo | undefined>;
    fetch: typeof globalThis.fetch;
    logout: (sessionId: string) => Promise<void>;
    getSessionInfo: (sessionId: string) => Promise<(ISessionInfo & ISessionInternalInfo) | undefined>;
    getSessionIdAll: () => Promise<string[]>;
    registerSession: (sessionId: string) => Promise<void>;
    clearSessionAll: () => Promise<void>;
    getAllSessionInfo: () => Promise<ISessionInfo[]>;
    handleIncomingRedirect: (url: string, onNewRefreshToken?: ((newToken: string) => unknown) | undefined) => Promise<ISessionInfo | undefined>;
}
