import { fetch } from "cross-fetch";
import { KeyPair } from "@inrupt/solid-client-authn-core";
import { ITokenRefresher } from "../login/oidc/refresh/TokenRefresher";
export declare type RefreshOptions = {
    sessionId: string;
    refreshToken: string;
    tokenRefresher: ITokenRefresher;
    onNewRefreshToken?: (token: string) => unknown;
};
export declare function buildBearerFetch(accessToken: string, refreshOptions?: RefreshOptions): typeof fetch;
export declare type DpopHeaderPayload = {
    htu: string;
    htm: string;
    jti: string;
};
export declare function buildDpopFetch(accessToken: string, dpopKey: KeyPair, refreshOptions?: RefreshOptions): Promise<typeof fetch>;
