import { IIssuerConfig, IIssuerConfigFetcher, IStorageUtility } from "@inrupt/solid-client-authn-core";
import { IssuerMetadata } from "openid-client";
export declare const WELL_KNOWN_OPENID_CONFIG = ".well-known/openid-configuration";
export declare function configFromIssuerMetadata(metadata: IssuerMetadata): IIssuerConfig;
export declare function configToIssuerMetadata(config: IIssuerConfig): IssuerMetadata;
export default class IssuerConfigFetcher implements IIssuerConfigFetcher {
    private storageUtility;
    constructor(storageUtility: IStorageUtility);
    static getLocalStorageKey(issuer: string): string;
    fetchConfig(issuer: string): Promise<IIssuerConfig>;
}
