import { IClientRegistrar, IIssuerConfigFetcher, IRedirectHandler, ISessionInfo, ISessionInfoManager, IStorageUtility } from "@inrupt/solid-client-authn-core";
import { ITokenRefresher } from "../refresh/TokenRefresher";
export declare class AuthCodeRedirectHandler implements IRedirectHandler {
    private storageUtility;
    private sessionInfoManager;
    private issuerConfigFetcher;
    private clientRegistrar;
    private tokenRefresher;
    constructor(storageUtility: IStorageUtility, sessionInfoManager: ISessionInfoManager, issuerConfigFetcher: IIssuerConfigFetcher, clientRegistrar: IClientRegistrar, tokenRefresher: ITokenRefresher);
    canHandle(redirectUrl: string): Promise<boolean>;
    handle(inputRedirectUrl: string, onNewRefreshToken?: (newToken: string) => unknown): Promise<ISessionInfo & {
        fetch: typeof fetch;
    }>;
}
