import { IClientRegistrar, IIssuerConfigFetcher, IStorageUtility, KeyPair } from "@inrupt/solid-client-authn-core";
import { TokenSet } from "openid-client";
export interface ITokenRefresher {
    refresh(localUserId: string, refreshToken?: string, dpopKey?: KeyPair, onNewRefreshToken?: (token: string) => unknown): Promise<TokenSet & {
        access_token: string;
    }>;
}
export default class TokenRefresher implements ITokenRefresher {
    private storageUtility;
    private issuerConfigFetcher;
    private clientRegistrar;
    constructor(storageUtility: IStorageUtility, issuerConfigFetcher: IIssuerConfigFetcher, clientRegistrar: IClientRegistrar);
    refresh(sessionId: string, refreshToken?: string, dpopKey?: KeyPair, onNewRefreshToken?: (newToken: string) => unknown): Promise<TokenSet & {
        access_token: string;
    }>;
}
