"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendToUrlPathname = void 0;
const url_1 = require("url");
function appendToUrlPathname(url, append) {
    try {
        const parsedUrl = new url_1.URL(url);
        const path = parsedUrl.pathname;
        parsedUrl.pathname = `${path}${path.endsWith("/") ? "" : "/"}${append.startsWith("/") ? append.substring(1) : append}`;
        return parsedUrl.toString();
    }
    catch (error) {
        throw new Error(`Failed to append [${append}] to the URL path of [${url}]. Error: ${error}`);
    }
}
exports.appendToUrlPathname = appendToUrlPathname;
//# sourceMappingURL=urlPath.js.map