import type { LogLevel } from 'componentsjs/lib/util/LogLevel';
import type { ResolutionContext } from '../resolution/ResolutionContext';
import type { PathDestinationDefinition } from '../serialize/ComponentConstructor';
/**
 * Generates a components file by parsing a typescript file.
 */
export declare class Generator {
    private readonly resolutionContext;
    private readonly pathDestination;
    private readonly fileExtension;
    private readonly ignoreClasses;
    private readonly typeScopedContexts;
    private readonly logLevel;
    private readonly prefix?;
    constructor(args: GeneratorArgs);
    generateComponents(): Promise<void>;
}
export interface GeneratorArgs {
    resolutionContext: ResolutionContext;
    pathDestination: PathDestinationDefinition;
    fileExtension: string;
    ignoreClasses: Record<string, boolean>;
    typeScopedContexts: boolean;
    logLevel: LogLevel;
    prefix?: string;
}
