"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArgumentConstructorHandlerList = void 0;
/**
 * Handles arguments with RDF list values.
 */
class ArgumentConstructorHandlerList {
    canHandle(value, settings, argsCreator) {
        return Boolean(value.list);
    }
    async handle(argument, settings, argsCreator) {
        // Recursively handle all sub-args in the list
        const elements = await Promise.all(argument.list
            .map((entry) => argsCreator.getArgumentValue(entry, settings)));
        return argsCreator.constructionStrategy.createArray({ settings, elements });
    }
}
exports.ArgumentConstructorHandlerList = ArgumentConstructorHandlerList;
//# sourceMappingURL=ArgumentConstructorHandlerList.js.map