import type { Resource } from 'rdf-object';
import type { IConstructionSettings } from '../IConstructionSettings';
import type { IArgumentConstructorHandler } from './IArgumentConstructorHandler';
import type { IArgumentsConstructor } from './IArgumentsConstructor';
/**
 * Handles IRI and blank node arguments as reference to another argument or instance.
 */
export declare class ArgumentConstructorHandlerReference implements IArgumentConstructorHandler {
    canHandle<Instance>(value: Resource, settings: IConstructionSettings, argsCreator: IArgumentsConstructor<Instance>): boolean;
    handle<Instance>(value: Resource, settings: IConstructionSettings, argsCreator: IArgumentsConstructor<Instance>): Promise<Instance>;
}
