import type { Resource } from 'rdf-object';
import type { IConstructionSettings } from '../IConstructionSettings';
import type { IArgumentConstructorHandler } from './IArgumentConstructorHandler';
import type { IArgumentsConstructor } from './IArgumentsConstructor';
/**
 * Handles value references, by recursively calling the args creator with the referred value.
 */
export declare class ArgumentConstructorHandlerValue implements IArgumentConstructorHandler {
    canHandle<Instance>(value: Resource, settings: IConstructionSettings, argsCreator: IArgumentsConstructor<Instance>): boolean;
    handle<Instance>(value: Resource, settings: IConstructionSettings, argsCreator: IArgumentsConstructor<Instance>): Promise<Instance>;
}
