"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConstructorArgumentsElementMappingHandlerFields = void 0;
/**
 * Handler for field definitions that contain key-value pairs to form a hash.
 */
class ConstructorArgumentsElementMappingHandlerFields {
    canHandle(configRoot, constructorArgs, configElement, mapper) {
        return Boolean(constructorArgs.property.fields);
    }
    handle(configRoot, constructorArgs, configElement, mapper) {
        // Recursively handle all field values.
        const ret = mapper.objectLoader.createCompactedResource({});
        for (const field of constructorArgs.properties.fields) {
            for (const mappedResource of mapper.applyConstructorArgumentsParameters(configRoot, field, configElement)) {
                ret.properties.fields.push(mappedResource);
            }
        }
        ret.property.unique = mapper.objectLoader.createCompactedResource('"true"');
        // Hack to enforce ArgumentConstructorHandlerHash
        ret.property.hasFields = mapper.objectLoader.createCompactedResource('"true"');
        return [ret];
    }
}
exports.ConstructorArgumentsElementMappingHandlerFields = ConstructorArgumentsElementMappingHandlerFields;
//# sourceMappingURL=ConstructorArgumentsElementMappingHandlerFields.js.map