"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterPropertyHandlerLazy = void 0;
/**
 * If the parameter is marked as lazy,
 * make the value inherit this lazy tag so that it can be handled later.
 */
class ParameterPropertyHandlerLazy {
    canHandle(value, configRoot, parameter, configElement) {
        return Boolean(parameter.property.lazy);
    }
    handle(value, configRoot, parameter, configElement) {
        for (const subValue of value) {
            subValue.property.lazy = parameter.property.lazy;
        }
        return value;
    }
}
exports.ParameterPropertyHandlerLazy = ParameterPropertyHandlerLazy;
//# sourceMappingURL=ParameterPropertyHandlerLazy.js.map