"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterPropertyHandlerRequired = void 0;
const ErrorResourcesContext_1 = require("../../util/ErrorResourcesContext");
/**
 * If no value has been set, but a value is required, throw.
 */
class ParameterPropertyHandlerRequired {
    constructor(objectLoader) {
        this.objectLoader = objectLoader;
    }
    canHandle(value, configRoot, parameter, configElement) {
        return Boolean(value.length === 0 && parameter.property.required);
    }
    handle(value, configRoot, parameter, configElement) {
        throw new ErrorResourcesContext_1.ErrorResourcesContext(`No value was set for required parameter "${parameter.value}"`, {
            config: configElement,
            parameter,
        });
    }
}
exports.ParameterPropertyHandlerRequired = ParameterPropertyHandlerRequired;
//# sourceMappingURL=ParameterPropertyHandlerRequired.js.map