/**
 * Compile a configuration stream to a JavaScript source file.
 * @param {string} mainModulePath The main module path.
 * @param {string} configPath Path of the config file.
 * @param {string} configIri IRI of the config element to compile.
 * @param {string} exportVariableName An optional variable name to export instead of the default runner.
 * @param {boolean} asFunction If the exported instance should be exposed as a function,
 *                             which accepts an optional hash of variables.
 * @param {boolean} skipContextValidation If JSON-LD context validation should be skipped.
 * @return {Promise<string>} A string resolving to the JavaScript contents.
 */
export declare function compileConfig(mainModulePath: string, configPath: string, configIri: string, exportVariableName?: string, asFunction?: boolean, skipContextValidation?: boolean): Promise<string>;
