import type { Resource } from 'rdf-object';
/**
 * An error that can include a context containing resources for display.
 */
export declare class ErrorResourcesContext extends Error {
    readonly context: Record<string, Resource | Resource[] | string>;
    constructor(message: string, context: Record<string, Resource | Resource[] | string>);
    static contextToString(context: Record<string, Resource | Resource[] | string>): string;
    /**
     * Convert the given resource to a compact string.
     * Mainly used for error reporting.
     *
     * Note that this will remove certain fields from the resource,
     * so only use this when throwing an error that will stop the process.
     *
     * @param resource A resource.
     */
    static resourceToString(resource: Resource): string;
}
