"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_string_1 = require("rdf-string");
function quadArrayToString(quadArray) {
    return '[ ' + quadArray.map((quad) => JSON.stringify(rdf_string_1.quadToStringQuad(quad))).join(', ') + ' ]';
}
exports.default = {
    toBeRdfDatasetContaining(dataset, ...quads) {
        for (const quad of quads) {
            if (!dataset.has(quad)) {
                return {
                    message: () => `expected dataset to have quads ${quadArrayToString(quads)}`,
                    pass: false,
                };
            }
        }
        return {
            message: () => `expected dataset to not have quads ${quadArrayToString(quads)}`,
            pass: true,
        };
    },
};
//# sourceMappingURL=toBeRdfDatasetContaining.js.map