"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_isomorphic_1 = require("rdf-isomorphic");
const rdf_string_1 = require("rdf-string");
function quadArrayToString(quadArray) {
    return '[\n' + quadArray.map((quad) => '  ' + JSON.stringify(rdf_string_1.quadToStringQuad(quad))).join(',\n') + '\n]';
}
exports.default = {
    toBeRdfIsomorphic(received, actual) {
        const receivedArray = [...received];
        const actualArray = [...actual];
        if (!rdf_isomorphic_1.isomorphic(receivedArray, actualArray)) {
            return {
                message: () => `expected two graphs to be isomorphic.

  Expected:
${quadArrayToString(actualArray)}

  Actual:
${quadArrayToString(receivedArray)}
`,
                pass: false,
            };
        }
        return {
            message: () => `expected two graphs not to be isomorphic.

  Expected:
${quadArrayToString(actualArray)}

  Actual:
${quadArrayToString(receivedArray)}
`,
            pass: true,
        };
    },
};
//# sourceMappingURL=toBeRdfIsomorphic.js.map