"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_string_1 = require("rdf-string");
const toEqualRdfTerm_1 = require("./toEqualRdfTerm");
exports.default = {
    toEqualRdfQuad(received, actual) {
        const s = toEqualRdfTerm_1.default.toEqualRdfTerm(received.subject, actual.subject);
        if (!s.pass) {
            return s;
        }
        const p = toEqualRdfTerm_1.default.toEqualRdfTerm(received.predicate, actual.predicate);
        if (!p.pass) {
            return p;
        }
        const o = toEqualRdfTerm_1.default.toEqualRdfTerm(received.object, actual.object);
        if (!o.pass) {
            return o;
        }
        const g = toEqualRdfTerm_1.default.toEqualRdfTerm(received.graph, actual.graph);
        if (!g.pass) {
            return g;
        }
        return {
            message: () => `expected
  ${JSON.stringify(rdf_string_1.quadToStringQuad(received))}
not to equal
  ${JSON.stringify(rdf_string_1.quadToStringQuad(actual))}`,
            pass: true,
        };
    },
};
//# sourceMappingURL=toEqualRdfQuad.js.map