"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_string_1 = require("rdf-string");
const toEqualRdfQuad_1 = require("./toEqualRdfQuad");
function quadArrayToString(quadArray) {
    return '[ ' + quadArray.map((quad) => JSON.stringify(rdf_string_1.quadToStringQuad(quad))).join(', ') + ' ]';
}
exports.default = {
    toEqualRdfQuadArray(received, actual) {
        if (received.length !== actual.length) {
            return {
                message: () => `expected ${quadArrayToString(received)} to equal ${quadArrayToString(actual)}`,
                pass: false,
            };
        }
        for (let i = 0; i < received.length; i++) {
            const q = toEqualRdfQuad_1.default.toEqualRdfQuad(received[i], actual[i]);
            if (!q.pass) {
                return q;
            }
        }
        return {
            message: () => `expected ${quadArrayToString(received)} not to equal ${quadArrayToString(actual)}`,
            pass: true,
        };
    },
};
//# sourceMappingURL=toEqualRdfQuadArray.js.map