"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_string_1 = require("rdf-string");
const toEqualRdfTerm_1 = require("./toEqualRdfTerm");
function termArrayToString(termArray) {
    return '[ ' + termArray.map((term) => JSON.stringify(rdf_string_1.termToString(term))).join(', ') + ' ]';
}
exports.default = {
    toEqualRdfTermArray(received, actual) {
        if (received.length !== actual.length) {
            return {
                message: () => `expected ${termArrayToString(received)} to equal ${termArrayToString(actual)}`,
                pass: false,
            };
        }
        for (let i = 0; i < received.length; i++) {
            const q = toEqualRdfTerm_1.default.toEqualRdfTerm(received[i], actual[i]);
            if (!q.pass) {
                return q;
            }
        }
        return {
            message: () => `expected ${termArrayToString(received)} not to equal ${termArrayToString(actual)}`,
            pass: true,
        };
    },
};
//# sourceMappingURL=toEqualRdfTermArray.js.map