#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_string_1 = require("rdf-string");
const __1 = require("..");
// tslint:disable:no-console
// tslint:disable:no-var-requires
const args = process.argv.slice(2);
if (args.length !== 1) {
    console.error(`rdf-dereference dereferences an RDF stream

Usage:
  rdf-dereference some-url
  rdf-dereference http://dbpedia.org/page/12_Monkeys
`);
    process.exit(1);
}
__1.default.dereference(args[0], { localFiles: true })
    .then((out) => {
    process.stdout.write('[');
    let first = true;
    out.quads.on('data', (quad) => {
        if (!first) {
            process.stdout.write(',\n');
        }
        else {
            process.stdout.write('\n');
        }
        first = false;
        process.stdout.write(JSON.stringify(rdf_string_1.quadToStringQuad(quad)));
    });
    out.quads.on('end', () => console.log('\n]'));
})
    .catch((error) => {
    console.error(error);
    process.exit(1);
});
//# sourceMappingURL=Runner.js.map