import { IActorRdfDereferenceOutput } from "@comunica/bus-rdf-dereference";
import * as RDF from "@rdfjs/types";
import { IDereferenceOptions, RdfDereferencerBase } from "./RdfDereferencerBase";
/**
 * An RdfDerefencer can dereference URLs to RDF streams, using any RDF serialization.
 */
export declare class RdfDereferencer<Q extends RDF.BaseQuad = RDF.Quad> extends RdfDereferencerBase<Q> {
    /**
     * Dereference the given URL to an RDF stream.
     * @param {string} url An HTTP(S) HTTPS URL, or a local file path.
     *                     Local file paths are only allowed when options.localFiles is enabled.
     * @param {IDereferenceOptions} options
     * @return {IActorRdfDereferenceOutput} The dereference output.
     */
    dereference(url: string, options?: IDereferenceOptions): Promise<IActorRdfDereferenceOutput>;
}
