import type { JsonLdContextNormalized } from 'jsonld-context-parser';
/**
 * A proxy handler for exposing a URI-to-? map to shortcut-to-? map
 * based on a JSON-LD context.
 */
export declare class ShortcutPropertyHandler<T> implements ProxyHandler<Record<string, T[]>> {
    private readonly context;
    constructor(context: JsonLdContextNormalized);
    has(target: Record<string, T[]>, propertyKey: string | symbol): boolean;
    get(target: Record<string, T[]>, propertyKey: string | symbol): T[];
    set(target: Record<string, T[]>, propertyKey: string | symbol, value: any): boolean;
    ownKeys(target: Record<string, T[]>): (string | symbol)[];
    private toTermString;
}
