/**
 * Literal Type
 * Pass value or set as const for correct type inference
 * See also https://www.typescriptlang.org/docs/handbook/literal-types.html
 */
export declare function isLiteral<T>(x: unknown, value: T): x is typeof value;
export declare function isLiteralType<T>(x: unknown, set: Set<T>): x is typeof set extends Set<infer T> ? T : never;
